function im_out = tophat(im,el)
% TOPHAT Top hat transformation of a grayscale image
% CMP Vision Algorithms http://visionbook.felk.cvut.cz
%
% Function tophat computes the top hat transformation of a
% grayscale image.
% Usage: im_out = tophat(im,el)
% Inputs:
%   im  [m x n]  Input image.
%   el  struct  Structuring element generated by the function strel.
% Outputs:   
%   im_out  [m x n]  Top hat.
% See also: imtophat.
im_out = imerode( im, el ); % erosion
im_out = imdilate( im_out, el ); % opening
im_out = im - im_out; % top hat
return


